/* Problem URL: https://codeforces.com/contest/118/problem/E */

#include <bits/stdc++.h>

using namespace std;

#define V vector

#define rmin(a, b) a = min(a, b)
#define rmax(a, b) a = max(a, b)

#define rep(i, lim) for (int i = 0; i < (lim); i++)
#define nrep(i, s, lim) for (int i = s; i < (lim); i++)

#define repv(i, v) for (auto &i : (v))
#define fillv(v) for (auto &itr_ : (v)) { cin >> itr_; }
#define sortv(v) sort(v.begin(), v.end())
#define all(v) (v).begin(), (v).end()

using vi = vector<int>;
using vvi = vector<vi>;
using vvvi = vector<vvi>;
using vvvvi = vector<vvvi>;

using ll = long long;

using vl = vector<ll>;
using vvl = vector<vl>;
using vvvl = vector<vvl>;
using vvvvl = vector<vvvl>;

template<class v>
auto operator<<(ostream &os, const vector<v> &vec)->ostream& {
    os << vec[0];
    for (size_t i = 1; i < vec.size(); i++) {
        os << ' ' << vec[i];
    }
    os << '\n';
    return os;
}

template<class v>
auto operator>>(istream &is, vector<v> &vec)->istream& {
    for (auto &i : vec) {
        is >> i;
    }
    return is;
}

template<class v>
auto operator<<(ostream &os, const vector<vector<v>> &vec)->ostream& {
    for (auto &i : vec) {
        os << i[0];
        for (size_t j = 1; j < i.size(); j++) {
            os << ' ' << i[j];
        }
        os << '\n';
    }
    return os;
}

template<class v>
auto operator>>(istream  &is, vector<vector<v>> &vec)->istream& {
    for (auto &i : vec) {
        for (auto &j : i) {
            is >> j;
        }
    }
    return is;
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int n, m;
    cin >> n >> m;

    vvi graph(n);
    rep(i, m) {
        int a, b;
        cin >> a >> b;
        a--, b--;
        graph[a].push_back(b);
        graph[b].push_back(a);
    }

    vvi dfstree(n);
    V<pair<int, int>> ans;
    vi up(n);
    vi down(n);
    vi lvl(n);

    function<void(int, int)> make_tree = [&](int i, int d) {
        lvl[i] = d;

        for (auto j : graph[i]) {
            if (lvl[j] != 0) {
                if (lvl[j] >= lvl[i]) {
                    ans.emplace_back(j, i);
                    down[i]++;
                    up[j]++;
                }
                continue;
            }

            ans.emplace_back(i, j);
            dfstree[i].push_back(j);
            make_tree(j, d + 1);
        }
    };

    make_tree(0, 1);
    vi dp(n);
    dp[0] = 1;

    function<bool(int)> check = [&](int i) {
        dp[i] += up[i];
        dp[i] -= down[i];

        for (auto j : dfstree[i]) {
            if (!check(j)) {
                return false;
            }

            dp[i] += dp[j];
        }

        return dp[i] != 0;
    };

    if (!check(0)) {
        cout << "0\n";
        return 0;
    }

    for (auto [u, v] : ans) {
        cout << u + 1 << ' ' << v + 1 << '\n';
    }
}
